/* ---------------------------------------------------------------------------
  TIMER.H    Low-level routines to handle hardware timer interrupt and to
             program hardware clock. Interface file.
             coolTimer Version 1.21a/C

  Copyright(c) 1993-96 by B-coolWare.  Written by Bobby Z.
 ---------------------------------------------------------------------------*/

#ifndef __C00L_TIMER_H
#define __C00L_TIMER_H

#define ctOk                  0
#define ctInvalidChannelIndex -1
#define ctInternalError       -666

#define ChannelCount          5         /* change this to increase/decrease */
                                        /* number of available channels */

typedef unsigned int uint;
typedef void * pointer;

typedef struct {
                pointer cHandler;
                uint    cRate;
                uint    cTicks;
               } TChannel;

#define TChannelRecSize 8       /* DO NOT CHANGE THIS VALUE !!! */

#ifdef __cplusplus
extern "C" {
#endif
void pascal setTimerSpeed( uint );
/* set timer speed to given value in times per second */

void pascal setTimerDelay( uint );
/* set hardware timer latch to given value */

void pascal grabTimer( void );
/* initialize coolTimer internal variables and intercept hardware timer
   interrupt */

void pascal resetTimer( void );
/* return system to previous state, release timer interrupt, deinitialize. */

int pascal setTimerHandler( uint, uint, pointer );
/* set timer handler on on given channel with given rate */

void pascal changeRate( uint, uint );
/* change rate for given channel to given value */

uint pascal ComputeDelay( uint );
/* internal routine, do not use it */

void pascal playSound( uint );
/* plays sound at given frequency thru PC speaker */

void pascal noSound( void );
/* silences PC speaker */

void pascal disableHandler( uint );
/* disable handler for given channel */

void pascal normTimerSpeed( void );
/* reset timer speed to default (~18.2 times per second) */

#ifdef __cplusplus
}
#endif

#endif
